package com.eactive.eai.batch.job.jobItem.kofc;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KOFCB_0630 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_KOFCB_0630() {
        //화일정보수신요구
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(1, "" + SEND_LENGTH, this.al_FieldProps[1]);

            //업무구분코드 - 센터 및 은행에서 업무구분을 위하여 SET
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            //거래구분코드 "R"-센터 수신 업무, "S"-센터 송신업무
            //compileField(5, this.getFldTrClass(), this.al_FieldProps[5]);
            //기관별로 송수신시 사용되는 거래구분코드가 상이하여 기관별 속성값에서 참조하도록 함.
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND)) {
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_SEND), this.al_FieldProps[5]);
            }else{
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_RECV), this.al_FieldProps[5]);
            }
            //송수신 FLAG "C"-센터에서 전문을 발생할 시, "B"-은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            //화일명
            compileField(7, batchDoc.getBatchMsg().getHeader().getFileName() , this.al_FieldProps[7]);
            //응답코드
            compileField(8, TelegramKeys.RPS_HDB_RET_CODE_SUCCESS, this.al_FieldProps[8]);
            //화일 정보내역. 화일명+화일size+전문바이트수
            //RECV 0630/0640에서는 서로 교환한 값중 작은 값으로 결정한다.
            compileField(9, batchDoc.getBatchMsg().getHeader().getFileName(), this.al_FieldProps[9]);
            compileField(10, makeZero(""+batchDoc.getBatchMsg().getHeader().getFileSize(), 12), this.al_FieldProps[10]);
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // XX인 경우 길이를 1로 계산하므로 i=3 인 경우 실제 기관 코드 사용 길이-1 만큼을 더 해 준다.
            for (int i=2; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += ( getCalculatedLength(3) - 1 );
            REAL_SEND_LENGTH = SEND_LENGTH + getCalculatedLength(0) + ((byte[]) this.al_Field.get(1)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int fieldLen = -1;
        String propKey = "";
        switch (idx) {

        case 0:
            propKey = TelegramKeys.TRCD_LEN;
            break;

        case 3:
            propKey = TelegramKeys.ORGN_CD_LEN;
            break;

        default:
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        try {
            fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );

        } catch (Exception e) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = propKey;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        return fieldLen;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
        	 if (idx >= this.getFieldCount() ) {
                 logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                 String[] msgArgs = new String[2];
                 msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                 msgArgs[1] = ""+idx;
                 String errCode = "BECEAIFJI011";
                 String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                 this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                 return -1;
             }
             if (data.length < fldLen) {
                 logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                 String[] msgArgs = new String[2];
                 msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                 msgArgs[1] = ""+idx;
                 String errCode = "BECEAIFJI014";
                 String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                 this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                 return -1;
             }
            switch (idx) {
            case 0:
                // TR 코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );

                break;
            case 3:
                // 기관코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.BANK_CODE) + "          ").getBytes(), 0, data, 0, fldLen );

                break;

            default:
                break;
            }

            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}